# coding: utf-8

"""
    billing REST API documentation

    This document contains the public REST API definitions of the mbed-billing service.

    OpenAPI spec version: 1.4.4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ActiveServicePackage(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'created': 'datetime',
        'expires': 'datetime',
        'firmware_update_count': 'int',
        'grace_period': 'bool',
        'id': 'str',
        'modified': 'datetime',
        'next_id': 'str',
        'previous_id': 'str',
        'start_time': 'datetime'
    }

    attribute_map = {
        'created': 'created',
        'expires': 'expires',
        'firmware_update_count': 'firmware_update_count',
        'grace_period': 'grace_period',
        'id': 'id',
        'modified': 'modified',
        'next_id': 'next_id',
        'previous_id': 'previous_id',
        'start_time': 'start_time'
    }

    def __init__(self, created=None, expires=None, firmware_update_count=None, grace_period=None, id=None, modified=None, next_id=None, previous_id=None, start_time=None):
        """
        ActiveServicePackage - a model defined in Swagger
        """

        self._created = created
        self._expires = expires
        self._firmware_update_count = firmware_update_count
        self._grace_period = grace_period
        self._id = id
        self._modified = modified
        self._next_id = next_id
        self._previous_id = previous_id
        self._start_time = start_time
        self.discriminator = None

    @property
    def created(self):
        """
        Gets the created of this ActiveServicePackage.
        Service package creation time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :return: The created of this ActiveServicePackage.
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """
        Sets the created of this ActiveServicePackage.
        Service package creation time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :param created: The created of this ActiveServicePackage.
        :type: datetime
        """
        if created is None:
            raise ValueError("Invalid value for `created`, must not be `None`")

        self._created = created

    @property
    def expires(self):
        """
        Gets the expires of this ActiveServicePackage.
        Service package expiration time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :return: The expires of this ActiveServicePackage.
        :rtype: datetime
        """
        return self._expires

    @expires.setter
    def expires(self, expires):
        """
        Sets the expires of this ActiveServicePackage.
        Service package expiration time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :param expires: The expires of this ActiveServicePackage.
        :type: datetime
        """
        if expires is None:
            raise ValueError("Invalid value for `expires`, must not be `None`")

        self._expires = expires

    @property
    def firmware_update_count(self):
        """
        Gets the firmware_update_count of this ActiveServicePackage.
        Size of firmware update quota of this service package.

        :return: The firmware_update_count of this ActiveServicePackage.
        :rtype: int
        """
        return self._firmware_update_count

    @firmware_update_count.setter
    def firmware_update_count(self, firmware_update_count):
        """
        Sets the firmware_update_count of this ActiveServicePackage.
        Size of firmware update quota of this service package.

        :param firmware_update_count: The firmware_update_count of this ActiveServicePackage.
        :type: int
        """
        if firmware_update_count is None:
            raise ValueError("Invalid value for `firmware_update_count`, must not be `None`")

        self._firmware_update_count = firmware_update_count

    @property
    def grace_period(self):
        """
        Gets the grace_period of this ActiveServicePackage.
        Is this service package on grace period or not?

        :return: The grace_period of this ActiveServicePackage.
        :rtype: bool
        """
        return self._grace_period

    @grace_period.setter
    def grace_period(self, grace_period):
        """
        Sets the grace_period of this ActiveServicePackage.
        Is this service package on grace period or not?

        :param grace_period: The grace_period of this ActiveServicePackage.
        :type: bool
        """
        if grace_period is None:
            raise ValueError("Invalid value for `grace_period`, must not be `None`")

        self._grace_period = grace_period

    @property
    def id(self):
        """
        Gets the id of this ActiveServicePackage.
        ID of this service package.

        :return: The id of this ActiveServicePackage.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ActiveServicePackage.
        ID of this service package.

        :param id: The id of this ActiveServicePackage.
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")

        self._id = id

    @property
    def modified(self):
        """
        Gets the modified of this ActiveServicePackage.
        Service package latest modified time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :return: The modified of this ActiveServicePackage.
        :rtype: datetime
        """
        return self._modified

    @modified.setter
    def modified(self, modified):
        """
        Sets the modified of this ActiveServicePackage.
        Service package latest modified time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :param modified: The modified of this ActiveServicePackage.
        :type: datetime
        """
        if modified is None:
            raise ValueError("Invalid value for `modified`, must not be `None`")

        self._modified = modified

    @property
    def next_id(self):
        """
        Gets the next_id of this ActiveServicePackage.
        Next service package ID if this service package has a pending renewal or null.

        :return: The next_id of this ActiveServicePackage.
        :rtype: str
        """
        return self._next_id

    @next_id.setter
    def next_id(self, next_id):
        """
        Sets the next_id of this ActiveServicePackage.
        Next service package ID if this service package has a pending renewal or null.

        :param next_id: The next_id of this ActiveServicePackage.
        :type: str
        """

        self._next_id = next_id

    @property
    def previous_id(self):
        """
        Gets the previous_id of this ActiveServicePackage.
        Previous service package ID or null.

        :return: The previous_id of this ActiveServicePackage.
        :rtype: str
        """
        return self._previous_id

    @previous_id.setter
    def previous_id(self, previous_id):
        """
        Sets the previous_id of this ActiveServicePackage.
        Previous service package ID or null.

        :param previous_id: The previous_id of this ActiveServicePackage.
        :type: str
        """

        self._previous_id = previous_id

    @property
    def start_time(self):
        """
        Gets the start_time of this ActiveServicePackage.
        Service package start time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :return: The start_time of this ActiveServicePackage.
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """
        Sets the start_time of this ActiveServicePackage.
        Service package start time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :param start_time: The start_time of this ActiveServicePackage.
        :type: datetime
        """
        if start_time is None:
            raise ValueError("Invalid value for `start_time`, must not be `None`")

        self._start_time = start_time

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ActiveServicePackage):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
