# coding: utf-8

"""
    billing REST API documentation

    This document contains the public REST API definitions of the mbed-billing service.

    OpenAPI spec version: 1.4.4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class BillingReportRawDataResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'filename': 'str',
        'object': 'str',
        'url': 'str'
    }

    attribute_map = {
        'filename': 'filename',
        'object': 'object',
        'url': 'url'
    }

    def __init__(self, filename=None, object=None, url=None):
        """
        BillingReportRawDataResponse - a model defined in Swagger
        """

        self._filename = filename
        self._object = object
        self._url = url
        self.discriminator = None

    @property
    def filename(self):
        """
        Gets the filename of this BillingReportRawDataResponse.
        The filename of the raw billing data file to be downloaded. It contains the file extensions.

        :return: The filename of this BillingReportRawDataResponse.
        :rtype: str
        """
        return self._filename

    @filename.setter
    def filename(self, filename):
        """
        Sets the filename of this BillingReportRawDataResponse.
        The filename of the raw billing data file to be downloaded. It contains the file extensions.

        :param filename: The filename of this BillingReportRawDataResponse.
        :type: str
        """
        if filename is None:
            raise ValueError("Invalid value for `filename`, must not be `None`")

        self._filename = filename

    @property
    def object(self):
        """
        Gets the object of this BillingReportRawDataResponse.
        API Resource name.

        :return: The object of this BillingReportRawDataResponse.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this BillingReportRawDataResponse.
        API Resource name.

        :param object: The object of this BillingReportRawDataResponse.
        :type: str
        """
        if object is None:
            raise ValueError("Invalid value for `object`, must not be `None`")

        self._object = object

    @property
    def url(self):
        """
        Gets the url of this BillingReportRawDataResponse.
        The URL to download the raw billing data.

        :return: The url of this BillingReportRawDataResponse.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """
        Sets the url of this BillingReportRawDataResponse.
        The URL to download the raw billing data.

        :param url: The url of this BillingReportRawDataResponse.
        :type: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")

        self._url = url

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, BillingReportRawDataResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
