# coding: utf-8

"""
    billing REST API documentation

    This document contains the public REST API definitions of the mbed-billing service.

    OpenAPI spec version: 1.4.4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ReportBillingData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'active_devices': 'int',
        'firmware_updates': 'int',
        'generated': 'datetime',
        'period_end': 'datetime',
        'period_start': 'datetime'
    }

    attribute_map = {
        'active_devices': 'active_devices',
        'firmware_updates': 'firmware_updates',
        'generated': 'generated',
        'period_end': 'period_end',
        'period_start': 'period_start'
    }

    def __init__(self, active_devices=None, firmware_updates=None, generated=None, period_end=None, period_start=None):
        """
        ReportBillingData - a model defined in Swagger
        """

        self._active_devices = active_devices
        self._firmware_updates = firmware_updates
        self._generated = generated
        self._period_end = period_end
        self._period_start = period_start
        self.discriminator = None

    @property
    def active_devices(self):
        """
        Gets the active_devices of this ReportBillingData.

        :return: The active_devices of this ReportBillingData.
        :rtype: int
        """
        return self._active_devices

    @active_devices.setter
    def active_devices(self, active_devices):
        """
        Sets the active_devices of this ReportBillingData.

        :param active_devices: The active_devices of this ReportBillingData.
        :type: int
        """
        if active_devices is None:
            raise ValueError("Invalid value for `active_devices`, must not be `None`")
        if active_devices is not None and active_devices < 0:
            raise ValueError("Invalid value for `active_devices`, must be a value greater than or equal to `0`")

        self._active_devices = active_devices

    @property
    def firmware_updates(self):
        """
        Gets the firmware_updates of this ReportBillingData.

        :return: The firmware_updates of this ReportBillingData.
        :rtype: int
        """
        return self._firmware_updates

    @firmware_updates.setter
    def firmware_updates(self, firmware_updates):
        """
        Sets the firmware_updates of this ReportBillingData.

        :param firmware_updates: The firmware_updates of this ReportBillingData.
        :type: int
        """
        if firmware_updates is None:
            raise ValueError("Invalid value for `firmware_updates`, must not be `None`")
        if firmware_updates is not None and firmware_updates < 0:
            raise ValueError("Invalid value for `firmware_updates`, must be a value greater than or equal to `0`")

        self._firmware_updates = firmware_updates

    @property
    def generated(self):
        """
        Gets the generated of this ReportBillingData.
        Billing report generated time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :return: The generated of this ReportBillingData.
        :rtype: datetime
        """
        return self._generated

    @generated.setter
    def generated(self, generated):
        """
        Sets the generated of this ReportBillingData.
        Billing report generated time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :param generated: The generated of this ReportBillingData.
        :type: datetime
        """
        if generated is None:
            raise ValueError("Invalid value for `generated`, must not be `None`")

        self._generated = generated

    @property
    def period_end(self):
        """
        Gets the period_end of this ReportBillingData.
        Billing report end time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :return: The period_end of this ReportBillingData.
        :rtype: datetime
        """
        return self._period_end

    @period_end.setter
    def period_end(self, period_end):
        """
        Sets the period_end of this ReportBillingData.
        Billing report end time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :param period_end: The period_end of this ReportBillingData.
        :type: datetime
        """
        if period_end is None:
            raise ValueError("Invalid value for `period_end`, must not be `None`")

        self._period_end = period_end

    @property
    def period_start(self):
        """
        Gets the period_start of this ReportBillingData.
        Billing report start time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :return: The period_start of this ReportBillingData.
        :rtype: datetime
        """
        return self._period_start

    @period_start.setter
    def period_start(self, period_start):
        """
        Sets the period_start of this ReportBillingData.
        Billing report start time in RFC3339 date-time with millisecond accuracy and UTC time zone.

        :param period_start: The period_start of this ReportBillingData.
        :type: datetime
        """
        if period_start is None:
            raise ValueError("Invalid value for `period_start`, must not be `None`")

        self._period_start = period_start

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ReportBillingData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
