# coding: utf-8

"""
    billing REST API documentation

    This document contains the public REST API definitions of the mbed-billing service.

    OpenAPI spec version: 1.4.4
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ServicePackageQuotaHistoryResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'after': 'str',
        'data': 'list[ServicePackageQuotaHistoryItem]',
        'has_more': 'bool',
        'limit': 'int',
        'object': 'str',
        'total_count': 'int'
    }

    attribute_map = {
        'after': 'after',
        'data': 'data',
        'has_more': 'has_more',
        'limit': 'limit',
        'object': 'object',
        'total_count': 'total_count'
    }

    def __init__(self, after=None, data=None, has_more=None, limit=None, object=None, total_count=None):
        """
        ServicePackageQuotaHistoryResponse - a model defined in Swagger
        """

        self._after = after
        self._data = data
        self._has_more = has_more
        self._limit = limit
        self._object = object
        self._total_count = total_count
        self.discriminator = None

    @property
    def after(self):
        """
        Gets the after of this ServicePackageQuotaHistoryResponse.
        After which quota history id this paged response is fetched.

        :return: The after of this ServicePackageQuotaHistoryResponse.
        :rtype: str
        """
        return self._after

    @after.setter
    def after(self, after):
        """
        Sets the after of this ServicePackageQuotaHistoryResponse.
        After which quota history id this paged response is fetched.

        :param after: The after of this ServicePackageQuotaHistoryResponse.
        :type: str
        """
        if after is not None and len(after) > 32:
            raise ValueError("Invalid value for `after`, length must be less than or equal to `32`")
        if after is not None and len(after) < 32:
            raise ValueError("Invalid value for `after`, length must be greater than or equal to `32`")

        self._after = after

    @property
    def data(self):
        """
        Gets the data of this ServicePackageQuotaHistoryResponse.
        List of history items, empty list if no entries are available.

        :return: The data of this ServicePackageQuotaHistoryResponse.
        :rtype: list[ServicePackageQuotaHistoryItem]
        """
        return self._data

    @data.setter
    def data(self, data):
        """
        Sets the data of this ServicePackageQuotaHistoryResponse.
        List of history items, empty list if no entries are available.

        :param data: The data of this ServicePackageQuotaHistoryResponse.
        :type: list[ServicePackageQuotaHistoryItem]
        """
        if data is None:
            raise ValueError("Invalid value for `data`, must not be `None`")

        self._data = data

    @property
    def has_more(self):
        """
        Gets the has_more of this ServicePackageQuotaHistoryResponse.
        If there is next available quota history paged response to be fetched.

        :return: The has_more of this ServicePackageQuotaHistoryResponse.
        :rtype: bool
        """
        return self._has_more

    @has_more.setter
    def has_more(self, has_more):
        """
        Sets the has_more of this ServicePackageQuotaHistoryResponse.
        If there is next available quota history paged response to be fetched.

        :param has_more: The has_more of this ServicePackageQuotaHistoryResponse.
        :type: bool
        """
        if has_more is None:
            raise ValueError("Invalid value for `has_more`, must not be `None`")

        self._has_more = has_more

    @property
    def limit(self):
        """
        Gets the limit of this ServicePackageQuotaHistoryResponse.
        Maximum amount of quota history entries contained in one paged response.

        :return: The limit of this ServicePackageQuotaHistoryResponse.
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """
        Sets the limit of this ServicePackageQuotaHistoryResponse.
        Maximum amount of quota history entries contained in one paged response.

        :param limit: The limit of this ServicePackageQuotaHistoryResponse.
        :type: int
        """
        if limit is None:
            raise ValueError("Invalid value for `limit`, must not be `None`")
        if limit is not None and limit > 1000:
            raise ValueError("Invalid value for `limit`, must be a value less than or equal to `1000`")
        if limit is not None and limit < 2:
            raise ValueError("Invalid value for `limit`, must be a value greater than or equal to `2`")

        self._limit = limit

    @property
    def object(self):
        """
        Gets the object of this ServicePackageQuotaHistoryResponse.
        Always set to 'service-package-quota-history'.

        :return: The object of this ServicePackageQuotaHistoryResponse.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this ServicePackageQuotaHistoryResponse.
        Always set to 'service-package-quota-history'.

        :param object: The object of this ServicePackageQuotaHistoryResponse.
        :type: str
        """
        if object is None:
            raise ValueError("Invalid value for `object`, must not be `None`")
        allowed_values = ["service-package-quota-history"]
        if object not in allowed_values:
            raise ValueError(
                "Invalid value for `object` ({0}), must be one of {1}"
                .format(object, allowed_values)
            )

        self._object = object

    @property
    def total_count(self):
        """
        Gets the total_count of this ServicePackageQuotaHistoryResponse.
        Sum of all quota history entries that should be returned

        :return: The total_count of this ServicePackageQuotaHistoryResponse.
        :rtype: int
        """
        return self._total_count

    @total_count.setter
    def total_count(self, total_count):
        """
        Sets the total_count of this ServicePackageQuotaHistoryResponse.
        Sum of all quota history entries that should be returned

        :param total_count: The total_count of this ServicePackageQuotaHistoryResponse.
        :type: int
        """
        if total_count is None:
            raise ValueError("Invalid value for `total_count`, must not be `None`")
        if total_count is not None and total_count < 0:
            raise ValueError("Invalid value for `total_count`, must be a value greater than or equal to `0`")

        self._total_count = total_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ServicePackageQuotaHistoryResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
