# coding: utf-8

"""
    Bootstrap API

    Mbed Cloud Bootstrap API allows web applications to control the device bootstrapping process.

    OpenAPI spec version: 2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PreSharedKey(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'endpoint_name': 'str',
        'secret_hex': 'str'
    }

    attribute_map = {
        'endpoint_name': 'endpoint_name',
        'secret_hex': 'secret_hex'
    }

    def __init__(self, endpoint_name=None, secret_hex=None):
        """
        PreSharedKey - a model defined in Swagger
        """

        self._endpoint_name = endpoint_name
        self._secret_hex = secret_hex
        self.discriminator = None

    @property
    def endpoint_name(self):
        """
        Gets the endpoint_name of this PreSharedKey.
        The unique endpoint identifier that this pre-shared key applies to. 16-64 [printable](https://en.wikipedia.org/wiki/ASCII#Printable_characters) (non-control) ASCII characters.

        :return: The endpoint_name of this PreSharedKey.
        :rtype: str
        """
        return self._endpoint_name

    @endpoint_name.setter
    def endpoint_name(self, endpoint_name):
        """
        Sets the endpoint_name of this PreSharedKey.
        The unique endpoint identifier that this pre-shared key applies to. 16-64 [printable](https://en.wikipedia.org/wiki/ASCII#Printable_characters) (non-control) ASCII characters.

        :param endpoint_name: The endpoint_name of this PreSharedKey.
        :type: str
        """
        if endpoint_name is None:
            raise ValueError("Invalid value for `endpoint_name`, must not be `None`")
        if endpoint_name is not None and not re.search('^[ -~]{16,64}$', endpoint_name):
            raise ValueError("Invalid value for `endpoint_name`, must be a follow pattern or equal to `/^[ -~]{16,64}$/`")

        self._endpoint_name = endpoint_name

    @property
    def secret_hex(self):
        """
        Gets the secret_hex of this PreSharedKey.
        The secret of the pre-shared key in hexadecimal. It is not case sensitive; 4a is same as 4A, and it is allowed with or without 0x in the beginning. The minimum length of the secret is 128 bits and maximum 256 bits.

        :return: The secret_hex of this PreSharedKey.
        :rtype: str
        """
        return self._secret_hex

    @secret_hex.setter
    def secret_hex(self, secret_hex):
        """
        Sets the secret_hex of this PreSharedKey.
        The secret of the pre-shared key in hexadecimal. It is not case sensitive; 4a is same as 4A, and it is allowed with or without 0x in the beginning. The minimum length of the secret is 128 bits and maximum 256 bits.

        :param secret_hex: The secret_hex of this PreSharedKey.
        :type: str
        """
        if secret_hex is None:
            raise ValueError("Invalid value for `secret_hex`, must not be `None`")
        if secret_hex is not None and not re.search('^(0[xX])?[0-9a-fA-F]{32,64}$', secret_hex):
            raise ValueError("Invalid value for `secret_hex`, must be a follow pattern or equal to `/^(0[xX])?[0-9a-fA-F]{32,64}$/`")

        self._secret_hex = secret_hex

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PreSharedKey):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
