# coding: utf-8

"""
    Bootstrap API

    Mbed Cloud Bootstrap API allows web applications to control the device bootstrapping process.

    OpenAPI spec version: 2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PreSharedKeyWithoutSecret(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'created_at': 'datetime',
        'endpoint_name': 'str'
    }

    attribute_map = {
        'created_at': 'created_at',
        'endpoint_name': 'endpoint_name'
    }

    def __init__(self, created_at=None, endpoint_name=None):
        """
        PreSharedKeyWithoutSecret - a model defined in Swagger
        """

        self._created_at = created_at
        self._endpoint_name = endpoint_name
        self.discriminator = None

    @property
    def created_at(self):
        """
        Gets the created_at of this PreSharedKeyWithoutSecret.
        The date-time (RFC3339) when this pre-shared key was uploaded to Mbed Cloud.

        :return: The created_at of this PreSharedKeyWithoutSecret.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """
        Sets the created_at of this PreSharedKeyWithoutSecret.
        The date-time (RFC3339) when this pre-shared key was uploaded to Mbed Cloud.

        :param created_at: The created_at of this PreSharedKeyWithoutSecret.
        :type: datetime
        """

        self._created_at = created_at

    @property
    def endpoint_name(self):
        """
        Gets the endpoint_name of this PreSharedKeyWithoutSecret.
        The unique endpoint identifier that this pre-shared key applies to. 16-64 [printable](https://en.wikipedia.org/wiki/ASCII#Printable_characters) (non-control) ASCII characters.

        :return: The endpoint_name of this PreSharedKeyWithoutSecret.
        :rtype: str
        """
        return self._endpoint_name

    @endpoint_name.setter
    def endpoint_name(self, endpoint_name):
        """
        Sets the endpoint_name of this PreSharedKeyWithoutSecret.
        The unique endpoint identifier that this pre-shared key applies to. 16-64 [printable](https://en.wikipedia.org/wiki/ASCII#Printable_characters) (non-control) ASCII characters.

        :param endpoint_name: The endpoint_name of this PreSharedKeyWithoutSecret.
        :type: str
        """
        if endpoint_name is None:
            raise ValueError("Invalid value for `endpoint_name`, must not be `None`")
        if endpoint_name is not None and not re.search('^[ -~]{16,64}$', endpoint_name):
            raise ValueError("Invalid value for `endpoint_name`, must be a follow pattern or equal to `/^[ -~]{16,64}$/`")

        self._endpoint_name = endpoint_name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PreSharedKeyWithoutSecret):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
