# device-directory
This is the API Documentation for the Mbed Device Directory service.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 3
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import device_directory 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import device_directory
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import device_directory
from device_directory.rest import ApiException
from pprint import pprint

# Configure API key authorization: Bearer
device_directory.configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# device_directory.configuration.api_key_prefix['Authorization'] = 'Bearer'
# create an instance of the API class
api_instance = device_directory.DefaultApi()
device = device_directory.DeviceDataPostRequest() # DeviceDataPostRequest | 

try:
    # Create a device
    api_response = api_instance.device_create(device)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DefaultApi->device_create: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.us-east-1.mbedcloud.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**device_create**](docs/DefaultApi.md#device_create) | **POST** /v3/devices/ | Create a device
*DefaultApi* | [**device_destroy**](docs/DefaultApi.md#device_destroy) | **DELETE** /v3/devices/{id}/ | Delete a device.
*DefaultApi* | [**device_event_list**](docs/DefaultApi.md#device_event_list) | **GET** /v3/device-events/ | List all device events.
*DefaultApi* | [**device_event_retrieve**](docs/DefaultApi.md#device_event_retrieve) | **GET** /v3/device-events/{device_event_id}/ | Retrieve a device event.
*DefaultApi* | [**device_list**](docs/DefaultApi.md#device_list) | **GET** /v3/devices/ | List all devices.
*DefaultApi* | [**device_log_list**](docs/DefaultApi.md#device_log_list) | **GET** /v3/devicelog/ | DEPRECATED: List all device events.
*DefaultApi* | [**device_log_retrieve**](docs/DefaultApi.md#device_log_retrieve) | **GET** /v3/devicelog/{device_event_id}/ | DEPRECATED: Retrieve a device event.
*DefaultApi* | [**device_query_create**](docs/DefaultApi.md#device_query_create) | **POST** /v3/device-queries/ | Create a device query
*DefaultApi* | [**device_query_destroy**](docs/DefaultApi.md#device_query_destroy) | **DELETE** /v3/device-queries/{query_id}/ | Delete a device query
*DefaultApi* | [**device_query_list**](docs/DefaultApi.md#device_query_list) | **GET** /v3/device-queries/ | List device queries.
*DefaultApi* | [**device_query_retrieve**](docs/DefaultApi.md#device_query_retrieve) | **GET** /v3/device-queries/{query_id}/ | Retrieve a device query.
*DefaultApi* | [**device_query_update**](docs/DefaultApi.md#device_query_update) | **PUT** /v3/device-queries/{query_id}/ | Update a device query
*DefaultApi* | [**device_retrieve**](docs/DefaultApi.md#device_retrieve) | **GET** /v3/devices/{id}/ | Get a devices
*DefaultApi* | [**device_update**](docs/DefaultApi.md#device_update) | **PUT** /v3/devices/{id}/ | Update a device


## Documentation For Models

 - [DeviceData](docs/DeviceData.md)
 - [DeviceDataPatchRequest](docs/DeviceDataPatchRequest.md)
 - [DeviceDataPostRequest](docs/DeviceDataPostRequest.md)
 - [DeviceDataPutRequest](docs/DeviceDataPutRequest.md)
 - [DeviceEqNeqFilter](docs/DeviceEqNeqFilter.md)
 - [DeviceEventData](docs/DeviceEventData.md)
 - [DeviceEventEqNeqFilter](docs/DeviceEventEqNeqFilter.md)
 - [DeviceEventGteLteFilter](docs/DeviceEventGteLteFilter.md)
 - [DeviceEventInNinFilter](docs/DeviceEventInNinFilter.md)
 - [DeviceEventPage](docs/DeviceEventPage.md)
 - [DeviceGteLteFilter](docs/DeviceGteLteFilter.md)
 - [DeviceInNinFilter](docs/DeviceInNinFilter.md)
 - [DevicePage](docs/DevicePage.md)
 - [DeviceQuery](docs/DeviceQuery.md)
 - [DeviceQueryEqNeqFilter](docs/DeviceQueryEqNeqFilter.md)
 - [DeviceQueryGteLteFilter](docs/DeviceQueryGteLteFilter.md)
 - [DeviceQueryInNinFilter](docs/DeviceQueryInNinFilter.md)
 - [DeviceQueryPage](docs/DeviceQueryPage.md)
 - [DeviceQueryPatchRequest](docs/DeviceQueryPatchRequest.md)
 - [DeviceQueryPostPutRequest](docs/DeviceQueryPostPutRequest.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author



