# coding: utf-8

"""
    Device Directory API

    This is the API Documentation for the Mbed Device Directory service.

    OpenAPI spec version: 3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class DeviceDataPutRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'auto_update': 'bool',
        'ca_id': 'str',
        'custom_attributes': 'dict(str, str)',
        'description': 'str',
        'device_key': 'str',
        'endpoint_name': 'str',
        'endpoint_type': 'str',
        'host_gateway': 'str',
        'name': 'str',
        'object': 'str'
    }

    attribute_map = {
        'auto_update': 'auto_update',
        'ca_id': 'ca_id',
        'custom_attributes': 'custom_attributes',
        'description': 'description',
        'device_key': 'device_key',
        'endpoint_name': 'endpoint_name',
        'endpoint_type': 'endpoint_type',
        'host_gateway': 'host_gateway',
        'name': 'name',
        'object': 'object'
    }

    def __init__(self, auto_update=None, ca_id=None, custom_attributes=None, description=None, device_key=None, endpoint_name=None, endpoint_type=None, host_gateway=None, name=None, object=None):
        """
        DeviceDataPutRequest - a model defined in Swagger
        """

        self._auto_update = auto_update
        self._ca_id = ca_id
        self._custom_attributes = custom_attributes
        self._description = description
        self._device_key = device_key
        self._endpoint_name = endpoint_name
        self._endpoint_type = endpoint_type
        self._host_gateway = host_gateway
        self._name = name
        self._object = object
        self.discriminator = None

    @property
    def auto_update(self):
        """
        Gets the auto_update of this DeviceDataPutRequest.
        DEPRECATED: Mark this device for automatic firmware update.

        :return: The auto_update of this DeviceDataPutRequest.
        :rtype: bool
        """
        return self._auto_update

    @auto_update.setter
    def auto_update(self, auto_update):
        """
        Sets the auto_update of this DeviceDataPutRequest.
        DEPRECATED: Mark this device for automatic firmware update.

        :param auto_update: The auto_update of this DeviceDataPutRequest.
        :type: bool
        """

        self._auto_update = auto_update

    @property
    def ca_id(self):
        """
        Gets the ca_id of this DeviceDataPutRequest.
        The certificate issuer's ID.

        :return: The ca_id of this DeviceDataPutRequest.
        :rtype: str
        """
        return self._ca_id

    @ca_id.setter
    def ca_id(self, ca_id):
        """
        Sets the ca_id of this DeviceDataPutRequest.
        The certificate issuer's ID.

        :param ca_id: The ca_id of this DeviceDataPutRequest.
        :type: str
        """
        if ca_id is not None and len(ca_id) > 500:
            raise ValueError("Invalid value for `ca_id`, length must be less than or equal to `500`")

        self._ca_id = ca_id

    @property
    def custom_attributes(self):
        """
        Gets the custom_attributes of this DeviceDataPutRequest.
        Up to five custom key-value attributes. Note that keys cannot start with a number.

        :return: The custom_attributes of this DeviceDataPutRequest.
        :rtype: dict(str, str)
        """
        return self._custom_attributes

    @custom_attributes.setter
    def custom_attributes(self, custom_attributes):
        """
        Sets the custom_attributes of this DeviceDataPutRequest.
        Up to five custom key-value attributes. Note that keys cannot start with a number.

        :param custom_attributes: The custom_attributes of this DeviceDataPutRequest.
        :type: dict(str, str)
        """

        self._custom_attributes = custom_attributes

    @property
    def description(self):
        """
        Gets the description of this DeviceDataPutRequest.
        The description of the device.

        :return: The description of this DeviceDataPutRequest.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this DeviceDataPutRequest.
        The description of the device.

        :param description: The description of this DeviceDataPutRequest.
        :type: str
        """
        if description is not None and len(description) > 2000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `2000`")

        self._description = description

    @property
    def device_key(self):
        """
        Gets the device_key of this DeviceDataPutRequest.
        The fingerprint of the device certificate.

        :return: The device_key of this DeviceDataPutRequest.
        :rtype: str
        """
        return self._device_key

    @device_key.setter
    def device_key(self, device_key):
        """
        Sets the device_key of this DeviceDataPutRequest.
        The fingerprint of the device certificate.

        :param device_key: The device_key of this DeviceDataPutRequest.
        :type: str
        """
        if device_key is not None and len(device_key) > 512:
            raise ValueError("Invalid value for `device_key`, length must be less than or equal to `512`")

        self._device_key = device_key

    @property
    def endpoint_name(self):
        """
        Gets the endpoint_name of this DeviceDataPutRequest.
        The endpoint name given to the device.

        :return: The endpoint_name of this DeviceDataPutRequest.
        :rtype: str
        """
        return self._endpoint_name

    @endpoint_name.setter
    def endpoint_name(self, endpoint_name):
        """
        Sets the endpoint_name of this DeviceDataPutRequest.
        The endpoint name given to the device.

        :param endpoint_name: The endpoint_name of this DeviceDataPutRequest.
        :type: str
        """
        if endpoint_name is not None and len(endpoint_name) > 64:
            raise ValueError("Invalid value for `endpoint_name`, length must be less than or equal to `64`")

        self._endpoint_name = endpoint_name

    @property
    def endpoint_type(self):
        """
        Gets the endpoint_type of this DeviceDataPutRequest.
        The endpoint type of the device. For example, the device is a gateway.

        :return: The endpoint_type of this DeviceDataPutRequest.
        :rtype: str
        """
        return self._endpoint_type

    @endpoint_type.setter
    def endpoint_type(self, endpoint_type):
        """
        Sets the endpoint_type of this DeviceDataPutRequest.
        The endpoint type of the device. For example, the device is a gateway.

        :param endpoint_type: The endpoint_type of this DeviceDataPutRequest.
        :type: str
        """
        if endpoint_type is not None and len(endpoint_type) > 64:
            raise ValueError("Invalid value for `endpoint_type`, length must be less than or equal to `64`")

        self._endpoint_type = endpoint_type

    @property
    def host_gateway(self):
        """
        Gets the host_gateway of this DeviceDataPutRequest.
        The `endpoint_name` of the host gateway, if appropriate.

        :return: The host_gateway of this DeviceDataPutRequest.
        :rtype: str
        """
        return self._host_gateway

    @host_gateway.setter
    def host_gateway(self, host_gateway):
        """
        Sets the host_gateway of this DeviceDataPutRequest.
        The `endpoint_name` of the host gateway, if appropriate.

        :param host_gateway: The host_gateway of this DeviceDataPutRequest.
        :type: str
        """

        self._host_gateway = host_gateway

    @property
    def name(self):
        """
        Gets the name of this DeviceDataPutRequest.
        The name of the device.

        :return: The name of this DeviceDataPutRequest.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this DeviceDataPutRequest.
        The name of the device.

        :param name: The name of this DeviceDataPutRequest.
        :type: str
        """
        if name is not None and len(name) > 128:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `128`")

        self._name = name

    @property
    def object(self):
        """
        Gets the object of this DeviceDataPutRequest.
        The API resource entity.

        :return: The object of this DeviceDataPutRequest.
        :rtype: str
        """
        return self._object

    @object.setter
    def object(self, object):
        """
        Sets the object of this DeviceDataPutRequest.
        The API resource entity.

        :param object: The object of this DeviceDataPutRequest.
        :type: str
        """

        self._object = object

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, DeviceDataPutRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
