"""
Enum module

This file is autogenerated from api specifications
"""

# Python 2 compatibility
from __future__ import unicode_literals
from builtins import str
from builtins import object


class BaseEnum(object):
    values = frozenset()

    def __setattr__(self, name, value):
        raise Exception("enum container values cannot be modified")


class UserStatusEnum(BaseEnum):
    """Represents the `UserStatusEnum` options

    as used by Mbed Cloud "accounts" functionality
    """

    ACTIVE = "ACTIVE"
    ENROLLING = "ENROLLING"
    INACTIVE = "INACTIVE"
    INVITED = "INVITED"
    RESET = "RESET"

    values = frozenset(("ACTIVE", "ENROLLING", "INACTIVE", "INVITED", "RESET"))


class ApiKeyStatusEnum(BaseEnum):
    """Represents the `ApiKeyStatusEnum` options

    as used by Mbed Cloud "accounts" functionality
    """

    ACTIVE = "ACTIVE"
    INACTIVE = "INACTIVE"

    values = frozenset(("ACTIVE", "INACTIVE"))


class MyAccountStatusEnum(BaseEnum):
    """Represents the `MyAccountStatusEnum` options

    as used by Mbed Cloud "accounts" functionality
    """

    ACTIVE = "ACTIVE"
    ENROLLING = "ENROLLING"
    RESTRICTED = "RESTRICTED"
    SUSPENDED = "SUSPENDED"

    values = frozenset(("ACTIVE", "ENROLLING", "RESTRICTED", "SUSPENDED"))


class MyAccountMfaStatusEnum(BaseEnum):
    """Represents the `MyAccountMfaStatusEnum` options

    as used by Mbed Cloud "accounts" functionality
    """

    ENFORCED = "enforced"
    OPTIONAL = "optional"

    values = frozenset(("enforced", "optional"))


class SubtenantAccountStatusEnum(BaseEnum):
    """Represents the `SubtenantAccountStatusEnum` options

    as used by Mbed Cloud "accounts" functionality
    """

    ACTIVE = "ACTIVE"
    ENROLLING = "ENROLLING"
    RESTRICTED = "RESTRICTED"
    SUSPENDED = "SUSPENDED"

    values = frozenset(("ACTIVE", "ENROLLING", "RESTRICTED", "SUSPENDED"))


class SubtenantAccountMfaStatusEnum(BaseEnum):
    """Represents the `SubtenantAccountMfaStatusEnum` options

    as used by Mbed Cloud "accounts" functionality
    """

    ENFORCED = "enforced"
    OPTIONAL = "optional"

    values = frozenset(("enforced", "optional"))
